import sys


class TeeStd(object):
    def __init__(self, queue, type, name, mode):

        self.queue = queue
        self.file = open(name, mode)
        if type == 'stderr':
            self.out_obj = sys.stderr
            sys.stderr = self
        else:
            self.out_obj = sys.stdout
            sys.stdout = self

    def write(self, data):
        self.file.write(data)
        self.queue.put(data)
